# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class Capabilities(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'is_admin': 'bool',
        'is_guest': 'bool',
        'is_mutable': 'bool'
    }

    attribute_map = {
        'is_admin': 'isAdmin',
        'is_guest': 'isGuest',
        'is_mutable': 'isMutable'
    }

    def __init__(self, is_admin=None, is_guest=None, is_mutable=None, _configuration=None):  # noqa: E501
        """Capabilities - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._is_admin = None
        self._is_guest = None
        self._is_mutable = None
        self.discriminator = None

        if is_admin is not None:
            self.is_admin = is_admin
        if is_guest is not None:
            self.is_guest = is_guest
        if is_mutable is not None:
            self.is_mutable = is_mutable

    @property
    def is_admin(self):
        """Gets the is_admin of this Capabilities.  # noqa: E501


        :return: The is_admin of this Capabilities.  # noqa: E501
        :rtype: bool
        """
        return self._is_admin

    @is_admin.setter
    def is_admin(self, is_admin):
        """Sets the is_admin of this Capabilities.


        :param is_admin: The is_admin of this Capabilities.  # noqa: E501
        :type: bool
        """

        self._is_admin = is_admin

    @property
    def is_guest(self):
        """Gets the is_guest of this Capabilities.  # noqa: E501


        :return: The is_guest of this Capabilities.  # noqa: E501
        :rtype: bool
        """
        return self._is_guest

    @is_guest.setter
    def is_guest(self, is_guest):
        """Sets the is_guest of this Capabilities.


        :param is_guest: The is_guest of this Capabilities.  # noqa: E501
        :type: bool
        """

        self._is_guest = is_guest

    @property
    def is_mutable(self):
        """Gets the is_mutable of this Capabilities.  # noqa: E501


        :return: The is_mutable of this Capabilities.  # noqa: E501
        :rtype: bool
        """
        return self._is_mutable

    @is_mutable.setter
    def is_mutable(self, is_mutable):
        """Sets the is_mutable of this Capabilities.


        :param is_mutable: The is_mutable of this Capabilities.  # noqa: E501
        :type: bool
        """

        self._is_mutable = is_mutable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Capabilities, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Capabilities):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Capabilities):
            return True

        return self.to_dict() != other.to_dict()
